#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <winuser.h>
#include <commctrl.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "resource.h"
#include "common.h"

//萔̒`
#define APP_CLASS_NAME		"uma_run"		//NX
#define WM_TASKTRAY			(WM_APP+100)
#define PI                  3.1415926535

#define MONITOR_MAX				4	//j^[̍ő吔

//O[oϐ̐錾
HINSTANCE g_hAppInstance;		//AvP[ṼCX^X
HWND g_hAppWnd;					//AvP[VHWND
char g_szSkinBmp[MAX_PATH];		//XLrbg}bṽt@C
char g_szExePath[MAX_PATH];		//
POINT g_WindowPos;				//EBhE̕\ʒu
HBITMAP g_hSkinBmp;				//XLrbg}bṽnh
BITMAP g_SkinBmp;				//XLrbg}bvBITMAP\
RECT g_rcDesktop[MONITOR_MAX];	//efXNgbv̉𑜓x
RECT g_rcMaximumDesktop;		//fXNgbv̑𑜓x
RECT g_rcWindow;				//EBhERECT
BOOL g_EnableDownload;			//_E[h̗L
int	g_MonitorCount;				//EBhE̐

NOTIFYICONDATA g_nIcon;			//
HMENU g_hMenuSub;				//
HICON g_hIconSmall;				//

POINT g_pMoveVector;
HBITMAP g_hLayerBitmap;			//

#define CHAR_WIDTH	48
#define CHAR_HEIGHT	47
#define CHAR_PAT	7

//--------------------------------------------------------------------------------------
//	}`j^[̏擾
BOOL CALLBACK MonitorEnumProc( HMONITOR hMonitor, HDC hdcMonitor,
			      LPRECT lprcMonitor, LPARAM dwData )
{
	if( g_MonitorCount < MONITOR_MAX )
	{
		SetRect( &(g_rcDesktop[g_MonitorCount]), 
			     lprcMonitor->left,
				 lprcMonitor->top,
				 lprcMonitor->right,
				 lprcMonitor->bottom );

		if( lprcMonitor->left < g_rcMaximumDesktop.left )
			g_rcMaximumDesktop.left = lprcMonitor->left;
		if( lprcMonitor->top < g_rcMaximumDesktop.top )
			g_rcMaximumDesktop.top = lprcMonitor->top;
		if( g_rcMaximumDesktop.right < lprcMonitor->right )
			g_rcMaximumDesktop.right = lprcMonitor->right;
		if( g_rcMaximumDesktop.bottom < lprcMonitor->bottom )
			g_rcMaximumDesktop.bottom = lprcMonitor->bottom;
	}
	g_MonitorCount++;
	return TRUE;	// TRUE͒TpCFALSEŏI
}

//--------------------------------------------------------------------------------------
//	EBhEW̃_ݒ
void SetWindowPosRand( void )
{
	if( rand() % 2 )
	{//Xʂ甭
		g_WindowPos.x = (rand() % (g_rcMaximumDesktop.right - g_rcMaximumDesktop.left)) + g_rcMaximumDesktop.left;
		g_pMoveVector.x = (rand() % 5) - 2;
		if( rand() % 2 )
		{
			g_WindowPos.y = g_rcMaximumDesktop.top - CHAR_HEIGHT;
			g_pMoveVector.y = (rand() % 2);
		}
		else
		{
			g_WindowPos.y = g_rcMaximumDesktop.bottom;
			g_pMoveVector.y = (rand() % 2) * -1;
		}
	}
	else
	{//Yʂ甭
		if( rand() % 2 )
		{
			g_WindowPos.x = g_rcMaximumDesktop.left - CHAR_WIDTH;
			g_pMoveVector.x = (rand() % 2);
		}
		else
		{
			g_WindowPos.x = g_rcMaximumDesktop.right;
			g_pMoveVector.x = (rand() % 2) * -1;
		}
		g_WindowPos.y = (rand() % (g_rcMaximumDesktop.bottom - g_rcMaximumDesktop.top)) + g_rcMaximumDesktop.top;
		g_pMoveVector.y = (rand() % 5) - 2;
	}

	g_pMoveVector.x = -4;
	g_pMoveVector.y = 2;

	{
		char str[64];
		wsprintf( str, "g_WindowPos = { %3d, %3d }\n", g_WindowPos.x, g_WindowPos.y );
		OutputDebugString( str );
		wsprintf( str, "g_pMoveVector = { %3d, %3d }\n", g_pMoveVector.x, g_pMoveVector.y );
		OutputDebugString( str );

	}
}

//--------------------------------------------------------------------------------------
//	
BOOL Initialize( void )
{
	strcpy( g_szSkinBmp, "default.bmp" );

	g_hSkinBmp = (HBITMAP)LoadImage( NULL, g_szSkinBmp, IMAGE_BITMAP, 0, 0,
		LR_LOADFROMFILE | LR_CREATEDIBSECTION );
	GetObject(g_hSkinBmp, sizeof(BITMAP), &g_SkinBmp);

	//fXNgbṽTCY𒲂ׂ
	g_MonitorCount = 0;
	ZeroMemory( g_rcDesktop, sizeof( g_rcDesktop ) );
	ZeroMemory( &g_rcMaximumDesktop, sizeof( g_rcMaximumDesktop ) );
	EnumDisplayMonitors(NULL, NULL, MonitorEnumProc, 0);

	srand( (unsigned)time( NULL ) );
	SetWindowPosRand();

	g_hLayerBitmap = CreateRGBBitmap( CHAR_WIDTH, CHAR_HEIGHT, 32 );

	return TRUE;
}

//--------------------------------------------------------------------------------------
//	I
void Finalize( void )
{
	DeleteObject( g_hSkinBmp );
	DeleteObject( g_hLayerBitmap );
	Shell_NotifyIcon( NIM_DELETE, &g_nIcon );
}

//--------------------------------------------------------------------------------------
//	ʂ̕`
void UpdateObjects( HWND hWnd, HDC hDC )
{
	HGDIOBJ hOldObject;
	HDC hMemDC;
	static int i = 0;

	hMemDC = CreateCompatibleDC(hDC);

	//XL`
	hOldObject = SelectObject( hMemDC, g_hSkinBmp );
	BitBlt( hDC, 0, 0, CHAR_WIDTH, CHAR_HEIGHT, hMemDC, (i % CHAR_PAT) * CHAR_WIDTH, 0, SRCCOPY | CAPTUREBLT );
	i++;
	SelectObject( hDC, hOldObject );
	DeleteDC(hMemDC);
}

//--------------------------------------------------------------------------------------
//	^C}[֐
void CALLBACK PeriodicalProc( HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime )
{
	static double x = 0,y = 0,a,b;
	RECT rcWnd;

	GetWindowRect( g_hAppWnd, &rcWnd );

	if( rcWnd.right < g_rcMaximumDesktop.left )
		g_WindowPos.x = g_rcMaximumDesktop.right - (int)x;

	if( rcWnd.bottom < g_rcMaximumDesktop.top )
		g_WindowPos.y = g_rcMaximumDesktop.bottom - (int)y;

	if( g_rcMaximumDesktop.right < rcWnd.left )
		g_WindowPos.x = g_rcMaximumDesktop.left - CHAR_WIDTH - (int)x;

	if( g_rcMaximumDesktop.bottom < rcWnd.top )
		g_WindowPos.y = g_rcMaximumDesktop.top - CHAR_HEIGHT - (int)y;

	g_WindowPos.x += g_pMoveVector.x;
	g_WindowPos.y += g_pMoveVector.y;

	{//C[̏Jn
		HDC hDesktopDC = GetDC( NULL );
		HDC hMemDC = CreateCompatibleDC( hDesktopDC );
		HGDIOBJ hOldObject;

		hOldObject = SelectObject( hMemDC, g_hLayerBitmap );//hMemDCɃobt@BitmapI
		UpdateObjects( NULL, hMemDC );//obt@֕`
		SelectObject( hMemDC, hOldObject );//
		
		UpdateLayeredMaskImage( 
			g_hAppWnd, 
			g_hLayerBitmap, 
			g_WindowPos.x + (long)x,
			g_WindowPos.y + (long)y,
			CHAR_WIDTH,
			CHAR_HEIGHT,
			RGB( 255, 0, 255 )
			);
		DeleteDC( hMemDC );
		ReleaseDC( NULL, hDesktopDC );
	}
}

//--------------------------------------------------------------------------------------
//	CEBhẼvV[W
LRESULT CALLBACK WindowProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static int offset_x,offset_y;
	static POINT old_wnd_pos;
	WINDOWPOS *wp;
	POINT cursor_pos;
	unsigned int count = 0;

	switch( uMsg )
	{
	case WM_CREATE :
//		SetTimer( NULL, NULL, 47, PeriodicalProc ); //21fps
		SetTimer( NULL, NULL, 40, PeriodicalProc ); //25fps
		break;
	case WM_DESTROY://	EBhEj
		PostQuitMessage( 0 );
		break;
	case WM_WINDOWPOSCHANGING :	//	EBhEZύX\A
		wp = (LPWINDOWPOS)lParam;
		if( wp )
			wp->hwndInsertAfter = HWND_TOPMOST;
		break;
	case WM_DISPLAYCHANGE ://	𑜓x̕ύXm
		g_MonitorCount = 0;
		ZeroMemory( g_rcDesktop, sizeof( g_rcDesktop ) );
		ZeroMemory( &g_rcMaximumDesktop, sizeof( g_rcMaximumDesktop ) );
		EnumDisplayMonitors(NULL, NULL, MonitorEnumProc, 0);
		break;
	case WM_TASKTRAY:
		if( lParam == WM_RBUTTONDOWN || lParam == WM_LBUTTONDOWN )
		{
			GetCursorPos(&cursor_pos);
			SetForegroundWindow( hWnd );
			TrackPopupMenu(
				g_hMenuSub,
				TPM_BOTTOMALIGN | TPM_LEFTALIGN | TPM_RIGHTBUTTON,
				cursor_pos.x, cursor_pos.y, 0, hWnd, NULL );
		}
		break;
	case WM_COMMAND :
		switch( LOWORD(wParam) )
		{
		case IDM_EXIT :
			PostQuitMessage( 0 );
			break;
		}
		break;
	}

	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

//--------------------------------------------------------------------------------------
//	WinMain
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	HMENU hMenu;

	if( Initialize() )
	{

		//EBhE쐬
		g_hAppInstance = hInstance;
		g_hAppWnd = InitWindow(
								hInstance, APP_CLASS_NAME,
								g_WindowPos.x, g_WindowPos.y,
								g_SkinBmp.bmWidth, g_SkinBmp.bmHeight,
								WindowProc, SW_SHOW );

		//^XNgC̃ACR쐬
		g_hIconSmall = (HICON)LoadImage(
			g_hAppInstance,
			MAKEINTRESOURCE(IDI_APP_ICON),
			IMAGE_ICON,16,16,0);
		g_nIcon.cbSize = sizeof(NOTIFYICONDATA);
		g_nIcon.uID = 1;
		g_nIcon.hWnd = g_hAppWnd;
		g_nIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_ICON | NIF_TIP;
		g_nIcon.hIcon = g_hIconSmall;
		g_nIcon.uCallbackMessage = WM_TASKTRAY;
		strcpy( g_nIcon.szTip, "UpdateLayeredWindowvO" );
		Shell_NotifyIcon( NIM_ADD, &g_nIcon );
		DeleteObject( g_hIconSmall );//ŏĂȂˁH

		//^XNgC̃j[쐬
		hMenu = LoadMenu( g_hAppInstance, MAKEINTRESOURCE(IDR_MENU1) );
		if( hMenu )
			g_hMenuSub = GetSubMenu( hMenu, 0 );
		else
			g_hMenuSub = NULL;

		while( GetMessage( &msg, NULL, 0, 0 ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}

		Finalize();
	}
	return 0;
}

